﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;


struct ShaderParams {
	stepsH: f32,
	stepsS: f32,
	stepsL: f32,
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%


@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	var front : vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);
	var rgb : vec3<f32> = c3_RGBtoHSL(front.rgb);
	
	var steps : vec3<f32> = vec3<f32>(shaderParams.stepsH - 1.0, shaderParams.stepsS - 1.0, shaderParams.stepsL - 1.0);
    rgb = floor(rgb * steps + vec3(0.5)) / steps;

	rgb = c3_HSLtoRGB(rgb);

	var output : FragmentOutput;
	output.color = vec4<f32>(rgb, front.a);
	return output;
} 
